package com.ruoyi.pay.service.impl;

import cn.hutool.core.bean.BeanUtil;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.core.domain.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import com.ruoyi.pay.domain.bo.PayRequireAttendanceReportBo;
import com.ruoyi.pay.domain.vo.PayRequireAttendanceReportVo;
import com.ruoyi.pay.domain.PayRequireAttendanceReport;
import com.ruoyi.pay.mapper.PayRequireAttendanceReportMapper;
import com.ruoyi.pay.service.IPayRequireAttendanceReportService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 应出勤报Service业务层处理
 *
 * @author ruoyi
 * @date 2025-05-12
 */
@RequiredArgsConstructor
@Service
public class PayRequireAttendanceReportServiceImpl implements IPayRequireAttendanceReportService {

    private final PayRequireAttendanceReportMapper baseMapper;

    /**
     * 查询应出勤报
     */
    @Override
    public PayRequireAttendanceReportVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 查询应出勤报列表
     */
    @Override
    public TableDataInfo<PayRequireAttendanceReportVo> queryPageList(PayRequireAttendanceReportBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<PayRequireAttendanceReport> lqw = buildQueryWrapper(bo);
        Page<PayRequireAttendanceReportVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询应出勤报列表
     */
    @Override
    public List<PayRequireAttendanceReportVo> queryList(PayRequireAttendanceReportBo bo) {
        LambdaQueryWrapper<PayRequireAttendanceReport> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<PayRequireAttendanceReport> buildQueryWrapper(PayRequireAttendanceReportBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<PayRequireAttendanceReport> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getTenantId() != null, PayRequireAttendanceReport::getTenantId, bo.getTenantId());
        lqw.eq(StringUtils.isNotBlank(bo.getYear()), PayRequireAttendanceReport::getYear, bo.getYear());
        lqw.eq(StringUtils.isNotBlank(bo.getMonth()), PayRequireAttendanceReport::getMonth, bo.getMonth());
        lqw.eq(bo.getEmployeeId() != null, PayRequireAttendanceReport::getEmployeeId, bo.getEmployeeId());
        lqw.like(StringUtils.isNotBlank(bo.getEmpName()), PayRequireAttendanceReport::getEmpName, bo.getEmpName());
        lqw.like(StringUtils.isNotBlank(bo.getDeptName()), PayRequireAttendanceReport::getDeptName, bo.getDeptName());
        lqw.eq(StringUtils.isNotBlank(bo.getRestType()), PayRequireAttendanceReport::getRestType, bo.getRestType());
        lqw.eq(bo.getRequireDays() != null, PayRequireAttendanceReport::getRequireDays, bo.getRequireDays());
        lqw.eq(bo.getAvtiveDays() != null, PayRequireAttendanceReport::getAvtiveDays, bo.getAvtiveDays());
        lqw.eq(bo.getAttendanceHours() != null, PayRequireAttendanceReport::getAttendanceHours, bo.getAttendanceHours());
        lqw.eq(bo.getOvertimeHours() != null, PayRequireAttendanceReport::getOvertimeHours, bo.getOvertimeHours());
        lqw.eq(bo.getHolidays() != null, PayRequireAttendanceReport::getHolidays, bo.getHolidays());
        lqw.eq(bo.getHolidayHours() != null, PayRequireAttendanceReport::getHolidayHours, bo.getHolidayHours());
        lqw.eq(bo.getLeaveDays() != null, PayRequireAttendanceReport::getLeaveDays, bo.getLeaveDays());
        return lqw;
    }

    /**
     * 新增应出勤报
     */
    @Override
    public Boolean insertByBo(PayRequireAttendanceReportBo bo) {
        PayRequireAttendanceReport add = BeanUtil.toBean(bo, PayRequireAttendanceReport.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改应出勤报
     */
    @Override
    public Boolean updateByBo(PayRequireAttendanceReportBo bo) {
        PayRequireAttendanceReport update = BeanUtil.toBean(bo, PayRequireAttendanceReport.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(PayRequireAttendanceReport entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 批量删除应出勤报
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteBatchIds(ids) > 0;
    }
}
